unit disptest1;
(*********************************************************
 * LC-Display-Testprogramm fr LC-Displaymodul           *
 * WD-C0801P mit SPI/MICROWIRE-Schnittstelle             *
 * copyright (c) Pollin Electronic http://www.pollin.de  *
 * & Tassilo Heeg http://www.theeg.de th@theeg.de        *
 * 19.01.2003                                            *
 * Sourcecode fr Borland Delphi 5                       *
 * fr Windows 95/98/ME/NT/2000/XP                       *
 *********************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls, Menus,inifiles, Spin;

type
  TDispChar = array[0..4] OF BYTE;
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Druckerschnittstelle1: TMenuItem;
    Beenden1: TMenuItem;
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Timer1: TTimer;
    Timer2: TTimer;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    procedure Druckerschnittstelle1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Beenden1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure RadioButton12Click(Sender: TObject);
  private
    { Private-Deklarationen }
    printerport: word; // Adresse der verwendeten LPT-Schnittstelle
    BiDirLPT: Boolean; // true, wenn Printerport bidirektional
    msdelay,delz: int64; // Bentigt, um Delay auszumessen
    outputenabled: BOOLEAN; // TRUE, wenn Ausgabe auf Display enabled ist
    scrollpos: integer; // Position fr Laufschrift
    procedure DelayUS(us: integer); // Verzgerung um us Mikrosekunden
    procedure SPIEnable; // Display auswhlen
    procedure SPIDisable; // Display abwhlen / Transfer abschlieen
    procedure SPISendByte(b: byte); // Sendet ein Byte ber die SPI-Schnittstelle
    function SPIRecvByte: BYTE; // Empfngt ein Byte ber die SPI-Schnittstelle
    procedure WriteString(s: string);// 8 Zeichen Text auf Display ausgeben
    function ReadString: string; // 8 Zeichen Text aus dem Display lesen
  public
    { Public-Deklarationen }
  end;

const cDispEnTime = 2500; //us Wartezeit nach CS = high

var
  Form1: TForm1;

implementation

uses zlportio, disptest2;
{$R *.DFM}

procedure TForm1.Druckerschnittstelle1Click(Sender: TObject);
begin
  case printerport of
    $378: form2.combobox1.itemindex:=0;
    $278: form2.combobox1.itemindex:=1;
    else form2.combobox1.itemindex:=2;
  end;
  form2.edit1.text:='$'+IntToHex(printerport,4);
  if form2.combobox1.itemindex<2 then begin
    form2.edit1.enabled:=FALSE;
    form2.edit1.color:=clBtnFace;
  end else begin
    form2.edit1.enabled:=true;
    form2.edit1.color:=clWhite;
  end;
  form2.checkbox1.checked:=BiDirLPT;
  if form2.showmodal<>idOK then exit;
  BiDirLPT:=form2.checkbox1.checked;
  case form2.combobox1.itemindex of
    0: printerport:=$378;
    1: printerport:=$278;
    else printerport:=StrToInt(form2.edit1.text);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var myini: TIniFile;
begin
  // Konfiguration (Printerport)
  myini:=TInifile.create(CHangeFileExt(Application.exename,'.INI'));
  printerport:=myini.readinteger('COMMON','LPTADDRESS',$378);
  BiDirLPT:=myini.readbool('COMMON','LPTBIDIR',FALSE);
  myini.free;
  // Sonstiges
  outputenabled:=TRUE;
end;

procedure TForm1.FormShow(Sender: TObject);
var t: TDateTime;
begin
  t:=now+(1/(86400*2));
  msdelay:=0;
  delz:=$7FFFFFFFFFFFFFFF;
  // Schleifenlaufzeit ausmessen, Durchlufe in einer halben Sekunde
  // brachial, funktioniert aber
  while (now<t) AND (msdelay<delz) do
    inc(msdelay);
  msdelay:=msdelay div 500;
  // Prfen, ob I/O-Treiber geladen
  IF NOT ZlIOStarted THEN
    ShowMessage('Der bentigte Treiber ZLPORTIO.SYS konnte nicht geladen werden. Das Testprogramm wird ohne diesen Treiber nicht mit Windows NT/2000/XP funktionieren!');
  // Text ausgeben
  Edit1Change(self);  
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var myini: TIniFile;
begin
  // Konfiguration (Printerport) sichern
  myini:=TInifile.create(CHangeFileExt(Application.exename,'.INI'));
  myini.writeinteger('COMMON','LPTADDRESS',printerport);
  myini.writebool('COMMON','LPTBIDIR',BiDirLPT);
  myini.free;
end;

procedure TForm1.Beenden1Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.DelayUS(us: integer);
// Verzgerung um us Mikrosekunden
var t: TDateTime;
    z: integer;
begin
  t:=now+(5/86400);  // Begrenzt auf 5 Sekunden, falls was schiefgeht
  for z:=1 to us div 1000 do begin
    delz:=0;
    while (now<t) AND (delz<msdelay) do
      inc(delz);
  end;
  z:=msdelay*(us mod 1000) div 1000;
  while (now<t) AND (delz<z) do
    inc(delz);
end;

procedure TForm1.SPIEnable;
begin
  PortWriteB(printerport,4); // Display enabled
  DelayUS(cDispEnTime); // warten, bis Display bereit fr Datenbyte
end;

procedure TForm1.SPIDisable;
begin
  PortWriteB(printerport,0); // Display disabled
end;

procedure TForm1.SPISendByte(b: byte);
// Sendet ein Byte ber die SPI-Schnittstelle
var bit,d: integer;
begin
  SPIEnable;
  for bit:=7 downto 0 do begin // 8 Bit rausschieben
    d:=((b SHR bit) AND 1);
    PortWriteB(printerport,d or 4);
    PortWriteB(printerport,d or 2+4); // Bit wird mit steigender Flanke bernommen
  end;
end;

function TForm1.SPIRecvByte: BYTE;
// Empfngt ein Byte ber die SPI-Schnittstelle
var bit,d: integer;
begin
  d:=0;
  SPIEnable;
  for bit:=7 downto 0 do begin // 8 Bit reinschieben
    PortWriteB($378,2+4); // SK = high
    d:=d shl 1;
    if (PortReadB($378+1) AND 128)=0 then d:=d or 1; // Daten lesen, Achtung, BUSY invertiert beim lesen
    PortWriteB($378,4); // SK=low, Daten werden mit fallender Flanke weitergeschoben
  end;
  result:=d;
end;

procedure TForm1.WriteString(s: string);
// 8 Zeichen Text auf Display ausgeben
var b: byte;
begin
  if not outputenabled then exit;
  while length(s)<8 do s:=s+' ';
  for b:=0 to 7 do begin
    SPISendByte(b+18);
    SPISendByte(ord(s[b+1]));
    SPIDisable; // Transfer abschlieen
  end;
end;

function TForm1.ReadString: string;
// 8 Zeichen Text aus dem Display lesen
var b: byte;
begin
  if not outputenabled then exit;
  result:='';
  for b:=0 to 7 do begin
    SPISendByte(b+18+128);
    result:=result+chr(SPIRecvByte);
    SPIDisable; // Transfer abschlieen
  end;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  outputenabled:=FALSE;
  BitBtn1.enabled:=NOT outputenabled;
  BitBtn2.enabled:=outputenabled;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  outputenabled:=TRUE;
  BitBtn1.enabled:=NOT outputenabled;
  BitBtn2.enabled:=outputenabled;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
// Display-Refresh-Timer, sorgt dafr, da nicht die Versionsnummer angezeigt wird
begin
  // Einfach ein Zeichen auslesen, aber nur, wenn Ausgabe an ist
  if outputenabled then begin
    SPISendByte(18+128);
    SPIRecvByte;
    SPIDisable; // Transfer abschlieen
  end;  
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  // Text der Edit-Zeile anzeigen
  WriteString(Edit1.Text);
  if length(Edit1.Text)>8 then begin
    // als Laufschrift anzeigen, aber nur wenn Uhr nicht angezeigt wird
    if not Checkbox1.checked then begin
      scrollpos:=1;
      Timer2.interval:=400;
      Timer2.enabled:=TRUE;
    end;
  end;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
// Laufschrift oder Uhr anzeigen
var st: string;
begin
  if CheckBox1.checked then begin
    // Uhr anzeigen
    WriteString(TimeToStr(time));
  end else begin
    // Laufschrift, wenn ntig
    if length(Edit1.Text)>8 then begin
      st:=Edit1.Text+'        '+copy(Edit1.Text,1,7);
      inc(scrollpos);
      if scrollpos>length(st)-7 then scrollpos:=1;
      WriteString(copy(st,scrollpos,8));
    end else
      Timer2.Enabled:=FALSE;
  end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.checked then begin
    //Uhr anzeigen
    Timer2.Interval:=500;
    Timer2.enabled:=true;
  end else
    Edit1Change(self);
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  BitBtn1Click(self); // Sicherstellen, da Ein/Ausgabe an ist
  ShowMessage('Angezeigt wird: '+ReadString+'');
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
var z: integer;
    s: string;
begin
  // Edit1 mit allen ASCII-Zeichen fllen
  s:='';
  for z:=8 to 255 do
    s:=s+chr(z);
  Edit1.Text:=s;
end;

procedure TForm1.RadioButton12Click(Sender: TObject);
begin
  // Zeichensatz-Auswahl gendert
  SPISendByte(28);
  if RadioButton1.checked then
    SPISendByte(128)
  else
    SPISendByte(0);
  SPIDisable; // Transfer abschlieen  
end;

end.
