#include <io.h>
#include <io8515.h>

void wait_ms(int iValue)
{
    long int i;
    for(i=0;i<5*iValue;i++)
    {
       outp(0,   TCNT0); //reset Timer0
       outp(0x02, TCCR0);  //Timer 0: CK/8
       while(inp(TCNT0)<200){} //Warten bis Byte 200 ist(0,0002 sec.)-> das ganze 5 mal->ca 1 ms
    }
    outp(0x00, TCCR0);  //Timer 0: STOP
}

void wait_us(int iValue)
{
    long int i;
    for(i=0;i<iValue;i++)
    {
        asm volatile("nop");
    }
}

//D : Datenbyte
//C : Befehlsbyte
void write_display(char D, char C) {

        int i;
        //SI : PIN 0
        //SK : PIN 1
        //SO : PIN 2
        //CS : PIN 3
        outp(0x00,PORTB);//cs low
        outp(0x08,PORTB); //cs high
        //Sende C (Befehlsbyte) invertiert
        for (i=7;i>0;i--) {
                //bits senden
                if (bit_is_set (C, i)) {
                        outp(0x0B,PORTB); //SK high und SI high
                } else {
                        outp(0x0A,PORTB); //SK high und SI low
                }
                wait_us(2);
                outp(0x08,PORTB); //SK low
                wait_us(2);
        }
        //Sende D (Befehlsbyte) invertiert
        for (i=7;i>0;i--) {
                //bits senden
                if (bit_is_set (D, i)) {
                        outp(0x0B,PORTB); //SK high und SI high
                } else {
                        outp(0x0A,PORTB); //SK high und SI low
                }
                wait_us(2);
                outp(0x08,PORTB); //SK low
                wait_us(2);
        }
        outp(0x00,PORTB);//cs low
}

int main(void) {
    outp (0xff,DDRB);	// Port B als Ausgang
    outp (0x00,PORTB);
    outp (0x00,DDRD);	// Port D als Eingang
    outp (0x01,PORTD);
        write_display(0x00, 0x1C); //Zeichensatz 1
    while(1){

        write_display(0x33, 0x12); //Zeichen auf Stelle 1


    }
}
